]> git.pld-linux.org Git - projects/rc-scripts.git/blame - lib/functions
do not reset RC_LOGGING when IN_SHUTDOWN is not set
[projects/rc-scripts.git] / lib / functions
CommitLineData
356d834b 1#!/bin/sh - keep it for file(1) to get bourne shell script result
7742e157 2# functions This file contains functions to be used by most or all
746a2130 3# shell scripts in the /etc/rc.d/init.d directory.
7742e157 4#
ec8b15cb 5# $Id$
7742e157
AF
6#
7# Author: Miquel van Smoorenburg, <miquels@drinkel.nl.mugnet.org>
8a835e11 8# Hacked by: Greg Galloway and Marc Ewing
ffe19b59 9# Modified for PLD Linux by:
ec8b15cb 10# Marek Obuchowicz <elephant@pld-linux.org>
fdc764ae
ER
11# Arkadiusz Miśkiewicz <misiek@pld-linux.org>
12# Michał Kochanowicz <mkochano@pld-linux.org>
13# Łukasz Pawelczyk <havner@pld-linux.org>
7742e157
AF
14
15# First set up a default search path.
f2dd2d31 16export PATH="/sbin:/usr/sbin:/bin:/usr/bin"
7742e157 17
d7e5835b 18# Set defaults
66f7cfac
ER
19if [ -z "$COLUMNS" -o -z "$LINES" ]; then
20 _setterm() {
21 set -- $(stty size 2>/dev/null)
22 LINES=${LINES:-$1}
23 COLUMNS=${COLUMNS:-$2}
24 }
25 _setterm
26 unset _setterm
27fi
ef72e56c
AM
28[ -z "$LINES" ] || [ "$LINES" -le 0 ] && LINES=40
29[ -z "$COLUMNS" ] || [ "$COLUMNS" -le 0 ] && COLUMNS=80
66f7cfac
ER
30export LINES COLUMNS
31INIT_COL=$((COLUMNS - 13))
9e9fac7d 32
503bfc80
AM
33# Set colors
34RED=1
35GREEN=2
36YELLOW=3
37BLUE=4
38MAGENTA=5
39CYAN=6
40WHITE=7
94b691da 41NORMAL=15
503bfc80
AM
42# Bold definition (second parameter to termput setaf)
43BOLD=1
44NOBOLD=0
45# Default colors
46CBRACKETS="$CYAN" # brackets [ ] color
47CDONE="$GREEN" # DONE and WORK color
48CBUSY="$MAGENTA" # BUSY color
49CFAIL="$RED" # FAIL and DIED color
50CPOWEREDBY="$CYAN" # "Powered by" color
51CPLD="$GREEN" # "PLD Linux Distribution" color
52CI="$RED" # Capital I color (press I to enter interactive startup)
53CRESMAN="$GREEN" # "Resource Manager" color
bca43764 54CHARS="" # Characters displayed on the beginning of show line
503bfc80
AM
55CCHARS="$NORMAL" # Color of these characters (look at /etc/sysconfig/init-colors.gentoo example)
56
31895ed1
ER
57# save from env, set by /sbin/service
58env_upstart=$USE_UPSTART
59
d7e5835b 60# Source configuration if available - may override default values
503bfc80 61[ -r /etc/sysconfig/init-colors ] && . /etc/sysconfig/init-colors
de1fc6ce 62[ -r /etc/sysconfig/system ] && . /etc/sysconfig/system
7f229d88 63[ -r /etc/sysconfig/bootsplash ] && . /etc/sysconfig/bootsplash
7e04fe0e 64
31895ed1
ER
65[ "$env_upstart" ] && USE_UPSTART=$env_upstart
66
9e22837c 67if [ -z "$VSERVER" -o "$VSERVER" = "detect" ]; then
ce397bd8
JR
68 {
69 while read _f _ctx; do
70 [ "$_f" = "VxID:" -o "$_f" = "s_context:" ] && break
71 done </proc/self/status
72 } 2>/dev/null
9e22837c
JR
73 if [ -z "$_ctx" -o "$_ctx" = "0" ]; then
74 VSERVER=no
75 else
76 VSERVER=yes
77 fi
55a4bc1b 78 unset _f _ctx
9e22837c
JR
79fi
80
2a7fa780
AM
81# VSERVER_ISOLATION_NET = isolation only inside of vserver guests
82if [ -z "$VSERVER_ISOLATION_NET" -o "$VSERVER_ISOLATION_NET" = "detect" ]; then
83 VSERVER_ISOLATION_NET=no
84 if [ "$VSERVER" = "yes" ]; then
46e27e96
ER
85 if [ -f /proc/self/nsproxy ]; then
86 {
87 while read _t _data; do
88 [ "$_t" = "net:" ] && break
89 done < /proc/self/nsproxy
90 } 2> /dev/null
91 else
92 # assume old kernel mode
93 VSERVER_ISOLATION_NET=yes
94 fi
2a7fa780
AM
95 if [ "${_data##*\(}" = "I)" ]; then
96 VSERVER_ISOLATION_NET=yes
97 fi
98 unset _f _data
99 fi
100fi
101
4132441e
ER
102# we need to know in functions if we were called from a terminal
103if [ -z "$ISATTY" ]; then
104 [ -t ] && ISATTY=yes || ISATTY=no
9cdf2de7 105 export ISATTY
4132441e
ER
106fi
107
18bd13ac 108is_yes() {
13a745bb 109 # Test syntax
ac1f65e1 110 if [ $# = 0 ]; then
13a745bb
AM
111 msg_usage " is_yes {value}"
112 return 2
113 fi
114
115 # Check value
116 case "$1" in
739070c4 117 yes|Yes|YES|true|True|TRUE|on|On|ON|Y|y|1)
13a745bb
AM
118 # true returns zero
119 return 0
120 ;;
739070c4 121 *)
13a745bb
AM
122 # false returns one
123 return 1
124 ;;
125 esac
126}
127
18bd13ac 128is_no() {
13a745bb 129 # Test syntax
ac1f65e1 130 if [ $# = 0 ]; then
13a745bb
AM
131 msg_usage " is_no {value}"
132 return 2
133 fi
134
135 case "$1" in
739070c4 136 no|No|NO|false|False|FALSE|off|Off|OFF|N|n|0)
13a745bb
AM
137 # true returns zero
138 return 0
139 ;;
739070c4 140 *)
13a745bb
AM
141 # false returns one
142 return 1
143 ;;
144 esac
145}
146
45e0ac73
ER
147# checks if file is empty
148# empty lines and lines beginning with hash are ignored
149is_empty_file() {
150 [ -s "$1" ] || return 0
a51d5138 151 grep -vqE "^(#|[[:blank:]]*$)" "$1" && return 1 || return 0
45e0ac73
ER
152}
153
1626fc86
ER
154# returns OK if $1 contains $2
155strstr() {
4ec13019
ER
156 local a=$2
157 [ "${1#*$a*}" = "$1" ] && return 1
1626fc86
ER
158 return 0
159}
160
9671c12b 161if is_yes "$FASTRC" || ! is_no "$IN_SHUTDOWN"; then
d84e0c78
JR
162 RC_LOGGING=no
163fi
164
bc94aa53 165if is_no "$RC_LOGGING"; then
18bd13ac 166 initlog() {
6d0838f4 167 RESULT=0
bb49a1c7 168 while [ "$1" != "${1##-}" ]; do
0a35929a 169 case $1 in
739070c4 170 -c)
5e6dfc29
JR
171 shift
172 $1
173 RESULT=$?
174 break
175 ;;
739070c4 176 *)
5e6dfc29
JR
177 shift
178 ;;
0a35929a
AM
179 esac
180 done
6d0838f4 181 return $RESULT
0a35929a
AM
182 }
183fi
184
18bd13ac 185kernelver() {
e9e5c299 186 local _x _y _z v v1 old_IFS ver
55a4bc1b
JR
187 {
188 read _x _y v _z
189 old_IFS=$IFS
e9e5c299
JR
190 # strip _* or -* from versions like: "2.6.25_vanilla-1", "2.6.25-1"
191 IFS='_-'
55a4bc1b 192 set -- $v
e9e5c299
JR
193 v1=${1}
194 IFS='.'
195 set -- $v1
55a4bc1b 196 IFS=$old_IFS
28d62f54 197
e9e5c299 198 ver=${3}
28d62f54 199 while [ ${#ver} -lt 3 ]; do ver="0$ver"; done
55a4bc1b 200 ver="$2$ver"
28d62f54 201 while [ ${#ver} -lt 6 ]; do ver="0$ver"; done
55a4bc1b 202 ver="$1$ver"
28d62f54 203 while [ ${#ver} -lt 9 ]; do ver="0$ver"; done
55a4bc1b 204 echo $ver
28d62f54 205 } < /proc/version
6f2d09b1
AM
206}
207
18bd13ac 208kernelverser() {
480529b0 209 local _x _y _z v v1 old_IFS ver
55a4bc1b
JR
210 {
211 read _x _y v _z
212 old_IFS=$IFS
e9e5c299
JR
213 # strip _* or -* from versions like: "2.6.25_vanilla-1", "2.6.25-1"
214 IFS='_-'
55a4bc1b 215 set -- $v
e9e5c299
JR
216 v1=${1}
217 IFS='.'
218 set -- $v1
55a4bc1b
JR
219 IFS=$old_IFS
220 ver=$2
ac1f65e1 221 while [ ${#ver} -lt 3 ]; do ver="0$ver"; done
55a4bc1b 222 ver="$1$ver"
ac1f65e1 223 while [ ${#ver} -lt 6 ]; do ver="0$ver"; done
55a4bc1b
JR
224 echo $ver
225 } </proc/version
6f2d09b1
AM
226}
227
18bd13ac 228kernelvermser() {
480529b0 229 local _x _y _z v v1 old_IFS ver
55a4bc1b
JR
230 {
231 read _x _y v _z
232 old_IFS=$IFS
e9e5c299
JR
233 # strip _* or -* from versions like: "2.6.25_vanilla-1", "2.6.25-1"
234 IFS='_-'
55a4bc1b 235 set -- $v
e9e5c299
JR
236 v1=${1}
237 IFS='.'
238 set -- $v1
55a4bc1b 239 IFS=$old_IFS
e9e5c299 240 ver="$1"
ac1f65e1 241 while [ ${#ver} -lt 3 ]; do ver="0$ver"; done
55a4bc1b
JR
242 echo $ver
243 } </proc/version
6f2d09b1
AM
244}
245
cee18a41 246# Colors workaround
18bd13ac 247termput() {
4132441e 248 is_yes "$ISATTY" || return
e3aafb2f 249
294b03eb 250 if is_yes "$FASTRC" || is_no "$TPUT"; then
972964bb 251 case "$1" in
739070c4 252 hpa)
8a835e11 253 echo -ne "\033[$(($2+1))G"
972964bb 254 ;;
739070c4 255 cuu*)
8a835e11 256 echo -ne "\033[${2}A"
972964bb 257 ;;
739070c4 258 el)
8a835e11 259 echo -ne "\033[0K"
972964bb 260 ;;
739070c4 261 setaf)
944d6d80 262 local ISBOLD
503bfc80
AM
263 if [ -n "$3" ]; then
264 ISBOLD="$3"
265 else
266 ISBOLD="$NOBOLD";
267 fi
268 is_yes "$COLOR_INIT" && echo -ne "\033[${ISBOLD};3${2}m"
8a835e11 269 ;;
739070c4 270 op)
503bfc80 271 termput setaf $NORMAL
dcb00bd9 272 ;;
8a835e11 273 esac
c6c1bd0c 274 else
8a835e11 275 case "$1" in
739070c4 276 hpa | cuu* | el)
8a835e11 277 tput "$@"
945790a2 278 ;;
739070c4 279 setaf)
ac1f65e1 280 if [ "$3" = "1" ]; then tput bold; else tput sgr0; fi
503bfc80 281 is_yes "$COLOR_INIT" && tput setaf "$2"
945790a2 282 ;;
739070c4 283 op)
503bfc80 284 termput setaf $NORMAL
945790a2 285 ;;
8a835e11 286 esac
c6c1bd0c
AF
287 fi
288}
cee18a41 289
0c4f3cf5
ER
290if [ ! -x /bin/printf ]; then
291 # printf equivalent
292 # FIXME: buggy when single or double quotes in message!
18bd13ac 293 printf() {
944d6d80 294 local text m
0c4f3cf5
ER
295 text="$1"
296 shift
297 if [ $# -gt 0 ]; then
298 m="$1"
299 shift
300 while [ $# -gt 0 ]; do
301 m="$m\",\"$1"
302 shift
303 done
304 fi
305 awk "BEGIN {printf \"$text\", \"$m\"; }"
306 }
307fi
8a835e11 308
38198f50 309# National language support function
18bd13ac 310nls() {
944d6d80 311 local msg_echo nls_domain text message
d553f606 312 msg_echo='\n'
50ed8c3f 313 nls_domain="$NLS_DOMAIN"
e2c2c3a6 314 while [ "$1" != "${1##-}" ]; do
d553f606 315 case "$1" in
739070c4 316 --nls-domain)
8a835e11 317 shift
50ed8c3f 318 nls_domain="$1"
8a835e11 319 shift
320 ;;
739070c4 321 -n)
8a835e11 322 msg_echo=''
323 shift
324 ;;
d553f606
JR
325 esac
326 done
327 message="$1"
328 shift
50ed8c3f 329
d553f606
JR
330 # empty message, so we return --misiek
331 if [ -z "$message" ]; then
d553f606
JR
332 echo -en "$msg_echo"
333 return
38198f50 334 fi
8a835e11 335
e2c2c3a6
ER
336 if is_yes "$GETTEXT"; then
337 message=$(TEXTDOMAINDIR="/etc/sysconfig/locale" gettext -e --domain="${nls_domain:-rc-scripts}" "$message")
972964bb 338 fi
8a835e11 339
e2c2c3a6 340 printf "$message" "$@"
d553f606 341 echo -en "$msg_echo"
38198f50
AM
342}
343
18bd13ac 344rc_splash() {
944d6d80 345 local action="$1"
862c980c 346
9e22837c 347 if ! is_no "$BOOT_SPLASH" && ! is_yes "$VSERVER"; then
fae22957
AM
348 [ -x /bin/splash ] && /bin/splash "$action"
349 fi
b6509675
AM
350
351 : $((progress++))
fae22957
AM
352}
353
18bd13ac 354msg_network_down() {
228edf1d 355 nls "ERROR: Networking is down. %s can't be run." "$1" >&2
a916d1c6 356}
357
18bd13ac 358msg_starting() {
a916d1c6 359 show "Starting %s service" "$1"
360}
361
18bd13ac 362msg_already_running() {
599d198a 363 nls "%s service is already running." "$1"
a916d1c6 364}
365
18bd13ac 366msg_stopping() {
a916d1c6 367 show "Stopping %s service" "$1"
368}
369
18bd13ac 370msg_not_running() {
599d198a 371 nls "%s service is not running." "$1"
a916d1c6 372}
373
18bd13ac 374msg_reloading() {
a916d1c6 375 show "Reloading %s service" "$1"
376}
377
18bd13ac 378msg_usage() {
599d198a 379 nls "Usage: %s" "$*"
a916d1c6 380}
381
ffe19b59 382# Some functions to handle PLD Linux-style messages
18bd13ac 383show() {
944d6d80 384 local text len
0a35929a 385
ce410bbc
JR
386 if is_no "$FASTRC" && is_yes "$GETTEXT"; then
387 text=$(nls -n "$@")
388 else
389 text=$(printf "$@")
390 fi
391 len=${#text}
392 while [ $((len++)) -lt $INIT_COL ]; do
393 text="$text."
394 done
395 if [ -n "$CHARS" ]; then
396 termput setaf $CCHARS
397 echo -n "$CHARS"
398 termput op
399 fi
400 echo -n "$text"
7742e157
AF
401}
402
18bd13ac 403deltext() {
a292b175
ER
404 termput hpa $INIT_COL
405}
406
b9cad282 407# Displays message in square brackests ("[ DONE ]"). Takes two arguments.
408# First is the text to display, second is color number to use (argument to
409# tput setaf). If second argument is not given, default (2, green) will be
410# used).
18bd13ac 411progress() {
944d6d80
ER
412 local COLOR
413 if [ -n "$2" ]; then
7e7efad2 414 COLOR="$2"
944d6d80 415 else
7e7efad2 416 COLOR="$CDONE"
944d6d80 417 fi
cd8dfdf0 418 deltext
503bfc80 419 echo -n "$(termput setaf $CBRACKETS)[$(termput setaf $COLOR) $(nls --nls-domain rc-scripts "$1") $(termput setaf $CBRACKETS)]$(termput op)"
b9cad282 420}
421
18bd13ac 422busy() {
a292b175 423 echo -n "$_busy"
7742e157
AF
424}
425
18bd13ac 426ok() {
a292b175 427 echo "$_ok"
7742e157
AF
428}
429
18bd13ac 430started() {
a292b175 431 echo "$_started"
7e04fe0e 432}
433
18bd13ac 434fail() {
a292b175 435 echo "$_fail"
d553f606 436 return 1
7742e157
AF
437}
438
18bd13ac 439died() {
a292b175 440 echo "$_died"
d553f606 441 return 1
6cac3cb2 442}
443
bbb612de 444# Check if $pid (could be plural) are running
18bd13ac 445checkpid() {
8a835e11 446 while [ "$1" ]; do
447 [ -d "/proc/$1" ] && return 0
448 shift
449 done
450 return 1
bbb612de
AM
451}
452
290eb891
AM
453# - outside chroot get only those processes, which are outside chroot.
454# - inside chroot get only those processes, which are inside chroot.
455# - don't filter out pids which do not have corresponding running processes (process died etc)
1e5e8177 456# (note: some processes like named are chrooted but run outside chroot)
c3403882 457# - do nothing inside vserver
18bd13ac 458filter_chroot() {
c3403882
JR
459 if is_yes "$VSERVER"; then
460 echo $@
461 return
462 fi
ac1f65e1 463 if [ $# -lt 1 -o ! -d /proc/1 ]; then
8e3b6875
AM
464 echo $@
465 return
466 fi
33ca787f 467 local root_dir good_pids="" good_add_pid
1e5e8177
AM
468 for root_pid in $@; do
469 root_dir=$(resolvesymlink /proc/${root_pid}/root)
470 if [ -n "$root_dir" ]; then
5a8ff397
AM
471 good_add_pid=1
472 if [ -n "${SYSTEM_CHROOTS}" ]; then
473 for r_dir in ${SYSTEM_CHROOTS}; do
474 echo "$root_dir" | grep -q "^${r_dir}" && good_add_pid=0
475 done
476 fi
477 [ "$good_add_pid" -eq 1 ] && good_pids="$good_pids $root_pid"
290eb891
AM
478 elif [ ! -d "/proc/$root_pid" ]; then
479 good_pids="$good_pids $root_pid"
1e5e8177 480 fi
5a8ff397
AM
481 done
482 echo $good_pids
1e5e8177
AM
483}
484
3e224b2a
ER
485# Usage:
486# run_cmd Message command_to_run
487# run_cmd -a Message command_to_run
488# run_cmd --user "username" "Message" command_to_run
18bd13ac 489run_cmd() {
3e224b2a
ER
490 local force_err=0 exit_code=0 errors user
491 while [ $# -gt 0 ]; do
492 case "$1" in
493 -a)
494 force_err=1
495 ;;
496 --user)
497 shift
498 user=$1
499 ;;
500 *)
501 break
502 esac
8a835e11 503 shift
3e224b2a
ER
504 done
505
506 local message=$1; shift
d553f606 507 show "$message"; busy
3e224b2a 508
f10f2102 509 if errors=$(
3e224b2a 510 cd /
f10f2102
ER
511 export HOME=/tmp TMPDIR=/tmp
512 if is_no "$RC_LOGGING"; then
3e224b2a 513 ${user:+setuidgid -s $user} "$@" 2>&1
f10f2102 514 else
3e224b2a 515 ${user:+setuidgid -s $user} initlog -c "$*" 2>&1
f10f2102
ER
516 fi
517 ); then
cd8dfdf0 518 ok
d553f606 519 log_success "$1 $message"
1b228409 520 else
d553f606
JR
521 fail
522 log_failed "$1 $message"
b7299ffc 523 exit_code=1
1b228409 524 fi
d553f606 525 [ -n "$errors" ] && [ $exit_code -eq 1 -o $force_err -eq 1 ] && echo "$errors"
1b228409 526 return $exit_code
cee18a41
AM
527}
528
e81194ca 529_daemon_set_ulimits() {
0fba6fe4
ER
530 local opt val ksh=${KSH_VERSION:+1}
531 set -- ${SERVICE_LIMITS:-$DEFAULT_SERVICE_LIMITS}
532 while [ $# -gt 0 ]; do
533 opt=$1
534 val=$2
535 if [ "$ksh" ]; then
536 case "$opt" in
537 -Hu)
538 opt=-Hp
539 ;;
540 -Su)
541 opt=-Sp
542 ;;
543 -u)
544 opt=-p
545 ;;
546 esac
547 fi
548 ulimit $opt $val
549 shift 2
550 done
e81194ca
ER
551}
552
e2e24f5a 553# A function to start a program (now it's useful on read-only filesystem too)
18bd13ac 554daemon() {
944d6d80
ER
555 local errors="" prog="" end="" waitname="" waittime=""
556 local exit_code=0
42595a81 557 local nice=$SERVICE_RUN_NICE_LEVEL
64c571c5 558 local fork user closefds redirfds pidfile makepid chdir=/
42595a81 559
210ff16f
ER
560 # NOTE: if you wonder how the shellish (by syntax) $prog works in ssd mode,
561 # then the answer is: it totally ignores $prog and uses "$@" itself.
562
42595a81 563 while [ $# -gt 0 ]; do
d553f606 564 case $1 in
739070c4 565 '')
64c571c5 566 msg_usage " daemon [--check] [--user user] [--fork] [--chdir directory] [--closefds] [--redirfds] [--waitforname procname] [--waitfortime seconds] [--pidfile file] [--makepid] [+/-nicelevel] {program} <program args>"
8a835e11 567 return 2
d553f606 568 ;;
739070c4 569 --check)
d553f606
JR
570 # for compatibility with redhat/mandrake
571 nls "warning: --check option is ignored!"
572 shift
d553f606 573 ;;
739070c4 574 --user)
d553f606 575 shift
f10f2102 576 user=$1
d553f606 577 ;;
739070c4
ER
578 --fork)
579 fork=1
b486c392 580 end='&'
b486c392 581 ;;
6b1fd029
ER
582 --chdir)
583 shift
584 chdir=$1
585 ;;
739070c4
ER
586 --closefds)
587 closefds=1
f10f2102 588 ;;
64c571c5
ER
589 --redirfds)
590 redirfds=1
591 ;;
739070c4 592 --waitforname)
b486c392 593 shift
683d384e 594 waitname="$1"
683d384e 595 ;;
739070c4 596 --waitfortime)
b486c392 597 shift
683d384e 598 waittime="$1"
683d384e 599 ;;
b2922b09
ER
600 --pidfile=?*)
601 pidfile="${1#--pidfile=}"
602 case "$pidfile" in /*);; *) pidfile="/var/run/$pidfile";; esac
603 ;;
739070c4 604 --pidfile)
0a177614
ER
605 shift
606 pidfile="$1"
5bf237b7 607 case "$pidfile" in /*);; *) pidfile="/var/run/$pidfile";; esac
0a177614 608 ;;
a160c01b
PG
609 --makepid)
610 makepid=1
611 ;;
739070c4 612 -*|+*)
42595a81 613 nice=$1
a6e727aa 614 shift
42595a81
ER
615 break
616 ;;
739070c4 617 *)
42595a81 618 break
683d384e 619 ;;
d553f606 620 esac
42595a81 621 shift
d553f606 622 done
af8469fc
KK
623 if [ -n "$user" -a "$user" != "root" ]; then
624 prog="/bin/su $user -s /bin/sh -c \""
625 fi
df2868ff 626 if [ "$fork" = "1" ]; then
af8469fc
KK
627 prog="/usr/bin/setsid ${prog:-sh -c \"}"
628 fi
2eea8492 629 # If command to execute ends with quotation mark, add remaining
630 # arguments and close quotation.
631 if [ "$prog" != "${prog%\"}" ]; then
565736ed 632 prog="$prog $*$end\""
2eea8492 633 else
565736ed 634 prog="$prog $*$end"
2eea8492 635 fi
7742e157 636
e81194ca 637 _daemon_set_ulimits
f054a85e 638
3edf5e48 639 [ -z "$DEFAULT_SERVICE_UMASK" ] && DEFAULT_SERVICE_UMASK=022
42595a81 640 [ -z "$DEFAULT_SERVICE_RUN_NICE_LEVEL" ] && DEFAULT_SERVICE_RUN_NICE_LEVEL=0
3edf5e48 641
7742e157
AF
642 # And start it up.
643 busy
6b1fd029 644 cd $chdir
42595a81 645 [ -n "$SERVICE_CPUSET" ] && is_yes "$CPUSETS" && echo $$ > "/dev/cpuset/${SERVICE_CPUSET}/tasks"
18bd13ac 646 if errors=$(
f10f2102 647 umask ${SERVICE_UMASK:-$DEFAULT_SERVICE_UMASK};
739070c4 648 export USER=root HOME=/tmp TMPDIR=/tmp
ab94cba2 649
f10f2102
ER
650 nice=${nice:-$DEFAULT_SERVICE_RUN_NICE_LEVEL}
651 nice=${nice:-0}
652
ab94cba2 653 # make nice level absolute, not to be dependant of nice level of shell where service started
667e4dd4 654 nice=$(($nice - $(nice)))
ab94cba2 655
f10f2102
ER
656 if [ "$closefds" = 1 ]; then
657 exec 1>&-
658 exec 2>&-
659 exec 0>&-
64c571c5
ER
660 elif [ "$redirfds" = 1 ]; then
661 exec 1>/dev/null
662 exec 2>/dev/null
663 exec 0>/dev/null
f10f2102
ER
664 else
665 exec 2>&1
666 fi
667
ac1f65e1 668 if is_no "$RC_LOGGING"; then
f10f2102
ER
669 prog=$1; shift
670 if [ ! -x $prog ]; then
671 logger -t rc-scripts -p daemon.debug "daemon: Searching PATH for $prog, consider using full path in initscript"
672 local a o=$IFS
673 IFS=:
674 for a in $PATH; do
675 if [ -x $a/$prog ]; then
676 prog=$a/$prog
677 break
678 fi
679 done
680 IFS=$o
681 fi
682 /sbin/start-stop-daemon -q --start \
683 --nicelevel $nice \
684 ${pidfile:+--pidfile $pidfile} \
86ed0b8f 685 ${makepid:+--make-pidfile} \
8a5b611f 686 ${user:+--chuid $user} \
6b1fd029 687 ${chdir:+--chdir "$chdir"} \
86ed0b8f
TP
688 ${fork:+--background} \
689 ${waitname:+--name $waitname} \
69bdc5ba 690 ${SERVICE_DROPCAPS:+--dropcap $SERVICE_DROPCAPS} \
f10f2102
ER
691 --exec "$prog" \
692 -- ${1:+"$@"}
693 else
8b8343d4 694 nice -n $nice initlog -c "$prog" 2>&1 </dev/null
f10f2102 695 fi
18bd13ac 696 ); then
f10f2102 697
683d384e
AM
698 if [ -n "$waitname" -a -n "$waittime" ]; then
699 # Save basename.
03e01a49 700 base=${waitname##*/}
683d384e
AM
701 # Find pid.
702 pid=$(pidofproc "$waitname" "$pidfile")
703 [ -z "$pid" ] && pid=$(pidofproc "$base" "$pidfile")
704 i=0
705 while [ "$i" -lt "$waittime" ]; do
42595a81 706 i=$((i + 1))
683d384e
AM
707 checkpid $pid && sleep 1 || break
708 done
709 fi
d553f606 710 log_success "$1 startup"
1b228409 711 ok
7742e157 712 else
b7299ffc 713 exit_code=1
1b228409 714 fail
d553f606 715 log_failed "$1 startup"
4fbe82fd 716 [ -n "$errors" ] && echo >&2 "$errors"
7742e157 717 fi
b7299ffc 718 return $exit_code
7742e157
AF
719}
720
721# A function to stop a program.
18bd13ac 722killproc() {
b2922b09 723 local notset killlevel base pid pidfile result delay=3 try
7742e157
AF
724 # Test syntax.
725 if [ $# = 0 ]; then
b2922b09 726 msg_usage " killproc [--pidfile|-p PIDFILE] [-d DELAY] {program} [-SIGNAME]"
228edf1d 727 return 2
7742e157
AF
728 fi
729
bb49a1c7 730 while [ "$1" != "${1##-}" ]; do
8de7f381 731 case $1 in
b2922b09
ER
732 -d)
733 delay="$2"
734 shift 2
735 ;;
a5363bea 736 --pidfile|-p)
53ae90e8 737 pidfile="$2"
5bf237b7 738 case "$pidfile" in /*);; *) pidfile="/var/run/$pidfile";; esac
53ae90e8 739 shift 2
8de7f381 740 ;;
739070c4 741 --waitforname)
53ae90e8
ER
742 waitname="$2"
743 shift 2
683d384e 744 ;;
739070c4 745 --waitfortime)
53ae90e8
ER
746 waittime="$2"
747 shift 2
683d384e 748 ;;
8de7f381
AM
749 esac
750 done
751
7742e157 752 busy
8a835e11 753
944d6d80 754 local notset=0
7742e157 755 # check for second arg to be kill level
ac1f65e1 756 if [ -n "$2" ]; then
7742e157
AF
757 killlevel=$2
758 else
759 notset=1
7742e157
AF
760 fi
761
2f269bdf
ER
762 # experimental start-stop-daemon based killing.
763 # works only with pidfile
764 if is_no "$RC_LOGGING" && [ "$pidfile" ]; then
6154a5ce
ER
765 local sig=${killlevel:--TERM} retry
766 # retry only if signal is not specified,
b2922b09 767 # as otherwise impossible to send HUP if process pid stays in pidfile.
6154a5ce
ER
768 if [ "${killlevel+set}" = "set" ]; then
769 # if we send HUP it's ok if process does not die
770 retry="--oknodo"
771 else
772 retry="--retry ${sig#-}/10/${sig#-}/60/KILL/10"
773 fi
2e00b711 774 /sbin/start-stop-daemon -q --stop \
6154a5ce 775 $retry \
2f269bdf
ER
776 -s ${sig#-} \
777 ${pidfile:+--pidfile $pidfile}
778 result=$?
779 if [ "$result" -eq 0 ]; then
780 ok
781 else
782 fail
783 fi
784 return $result
785 fi
786
787
228edf1d 788 # Save basename.
03e01a49 789 base=${1##*/}
7742e157 790
228edf1d 791 # Find pid.
8de7f381
AM
792 pid=$(pidofproc "$1" "$pidfile")
793 [ -z "$pid" ] && pid=$(pidofproc "$base" "$pidfile")
7742e157 794
228edf1d 795 # Kill it.
ac1f65e1
TP
796 if [ -n "$pid" -a "$pid" != "$$" ] && checkpid $pid 2>&1; then
797 if [ "$notset" = "1" ]; then
228edf1d 798 if checkpid $pid 2>&1; then
799 # TERM first, then KILL if not dead
800 kill -TERM $pid
b2922b09
ER
801 usleep 50000
802
803 try=0
804 while [ $try -lt $delay ]; do
805 checkpid $pid || break
806 sleep 1
807 try=$((try+1))
808 done
809 if checkpid $pid; then
53ae90e8
ER
810 # XXX: SIGKILL is sent already on 4th second!
811 # HARMFUL for example to mysqld (which is already workarounded)
228edf1d 812 kill -KILL $pid
b2922b09 813 usleep 50000
228edf1d 814 fi
7742e157 815 fi
228edf1d 816 checkpid $pid
bbb612de
AM
817 result=$?
818 if [ "$result" -eq 0 ]; then
228edf1d 819 fail
820 log_failed "$1 shutdown"
821 else
822 ok
823 log_success "$1 shutdown"
824 fi
825 result=$(( ! $result ))
826 else
827 # use specified level only
828 if checkpid $pid > /dev/null 2>&1; then
829 kill $killlevel $pid
830 result=$?
831 if [ "$result" -eq 0 ]; then
832 ok
833 log_success "$1 got $killlevel"
834 else
835 result=7
836 fail
837 log_failed "$1 didn't get $killlevel"
838 fi
e016cdae 839 else
228edf1d 840 result=7
841 died
842 log_failed "$1 shutdown"
e016cdae 843 fi
7742e157
AF
844 fi
845 else
228edf1d 846 died
847 log_failed "$1 shutdown"
848 result=7
7742e157 849 fi
5e6dfc29 850
683d384e 851 if [ -n "$waitname" -a -n "$waittime" ]; then
e6f93a80 852 # Save basename.
03e01a49 853 base=${waitname##*/}
e6f93a80
AM
854 # Find pid.
855 pid=$(pidofproc "$waitname" "$pidfile")
856 [ -z "$pid" ] && pid=$(pidofproc "$base" "$pidfile")
683d384e
AM
857 i=0
858 while [ "$i" -lt "$waittime" ]; do
1101d321 859 i=$(( i + 1 ))
683d384e
AM
860 checkpid $pid && sleep 1 || break
861 done
862 fi
7742e157 863
228edf1d 864 # Remove pid file if any.
e016cdae 865 if [ "$notset" = "1" ]; then
228edf1d 866 rm -f /var/run/${base}.pid
7742e157 867 fi
bbb612de
AM
868
869 return $result
7742e157
AF
870}
871
872# A function to find the pid of a program.
18bd13ac 873pidofproc() {
944d6d80 874 local pid pidfile base=${1##*/}
8de7f381
AM
875 pidfile="$base.pid"
876 [ -n "$2" ] && pidfile="$2"
7742e157 877
8a835e11 878 # Test syntax.
ac1f65e1 879 if [ $# = 0 ]; then
8a835e11 880 msg_usage " pidofproc {program}"
881 return 2
882 fi
883
8de7f381 884 # First try pidfile or "/var/run/*.pid"
5bf237b7
ER
885 case "$pidfile" in
886 /*)pidfile="${pidfile}";;
887 *) pidfile="/var/run/$pidfile";;
888 esac
ac1f65e1 889 if [ -f "${pidfile}" ]; then
944d6d80 890 local p pid=""
7eb94de6 891 for p in $(< "${pidfile}"); do
3030e60e 892 [ -z "$(echo "$p" | awk '{gsub(/[0-9]/,"");print;}')" ] && pid="$pid $p"
8a835e11 893 done
7742e157 894 fi
8a835e11 895
7742e157 896 # Next try "pidof"
1e5e8177
AM
897 [ -z "$pid" ] && pidof -o $$ -o $PPID -o %PPID -x "$1"
898 pid=$(filter_chroot "$pid")
899 echo $pid
7742e157 900}
12de71be 901
1b59b41b 902# status [--pidfile PIDFILE] {subsys} [{daemon}]"
18bd13ac 903status() {
944d6d80 904 local pid subsys daemon cpuset_msg pidfile
3232ec7b 905 if [ "$1" = "--pidfile" -o "$1" = "-p" ]; then
4e901aa0 906 pidfile=$2
5bf237b7 907 case "$pidfile" in /*);; *) pidfile="/var/run/$pidfile";; esac
4e901aa0
ER
908 shift 2
909 fi
910
8a835e11 911 subsys=$1
912 daemon=${2:-$subsys}
bbb612de 913
8a835e11 914 # Test syntax.
ac1f65e1 915 if [ $# = 0 ]; then
4e901aa0 916 msg_usage " status [--pidfile PIDFILE] {subsys} [{daemon}]"
8a835e11 917 return 2
918 fi
bbb612de 919
4e901aa0 920 # if pidfile specified, pid must be there
24ab860c
ER
921 if [ "$pidfile" ]; then
922 [ -f "$pidfile" ] && read pid < $pidfile
305c3281
ER
923 # filter_chroot does not filter out dead pids, so this extra check, see t/status-pidfile.sh
924 if [ ! -d "/proc/$pid" ]; then
925 pid=
926 fi
4e901aa0
ER
927 else
928 pid=$(pidof -o $$ -o $PPID -o %PPID -x $daemon)
929 fi
1e5e8177 930 pid=$(filter_chroot "$pid")
bbb612de 931
b90fbc1e 932 if [ "$pid" ]; then
814e38ce 933 cpuset_msg="..."
c51af89c
ER
934 if [ -n "$SERVICE_CPUSET" ] && is_yes "$CPUSETS"; then
935 if grep -q "$pid" "/dev/cpuset/${SERVICE_CPUSET}/tasks"; then
814e38ce
JR
936 cpuset_msg=$(nls " in cpuset %s..." "$SERVICE_CPUSET")
937 else
938 cpuset_msg=$(nls " outside of configured cpuset %s..." "$SERVICE_CPUSET")
939 fi
940 fi
941 nls "%s (pid %s) is running%s" "$daemon" "$pid" "$cpuset_msg"
8a835e11 942 return 0
8a835e11 943 fi
944
1b59b41b 945 # Next try "/var/run/*.pid" files; if pidfile is not set
4e901aa0 946 local base=${daemon##*/}
1b59b41b 947 if [ -z "$pidfile" -a -f /var/run/${base}.pid ]; then
8a835e11 948 read pid < /var/run/${base}.pid
1e5e8177 949 pid=$(filter_chroot "$pid")
1b59b41b
ER
950 if [ "$pid" ]; then
951 nls "%s dead but pid file (%s) exists" "$subsys" /var/run/${base}.pid
8a835e11 952 return 1
953 fi
954 fi
955
956 # See if /var/lock/subsys/$subsys exists
957 if [ -f /var/lock/subsys/$subsys ]; then
1b59b41b 958 nls "daemon %s dead but subsys (%s) locked" "$daemon" "$subsys"
8a835e11 959 return 2
7742e157 960 fi
8a835e11 961 nls "%s is stopped" "$subsys"
962 return 3
7742e157 963}
0524c81f 964
6b4a354c
AM
965# Confirm whether we really want to run this service
966confirm() {
944d6d80 967 local answer
d553f606 968 nls -n "Start service %s (Y)es/(N)o/(C)ontinue? [Y] " "$1"
6b4a354c
AM
969 read answer
970 case $answer in
739070c4 971 y|Y|t|T|j|J|"")
8a835e11 972 return 0
6b4a354c 973 ;;
739070c4 974 c|C|k|K|w|W)
8a835e11 975 return 2
6b4a354c 976 ;;
739070c4 977 n|N)
8a835e11 978 return 1
6b4a354c 979 ;;
739070c4 980 *)
8a835e11 981 confirm $1
982 return $?
6b4a354c
AM
983 ;;
984 esac
985}
986
d553f606 987# module is needed (ie. is requested, is available and isn't loaded already)
18bd13ac 988is_module() {
d553f606 989 # module name without .o at end
5778a670 990 if ! lsmod | grep -q "$1"; then
63d30ecf 991 if ls -1R /lib/modules/$(uname -r)/ 2> /dev/null | grep -q "^${1}.\(\|k\)o\(\|.gz\)"; then
d553f606
JR
992 # true
993 return 0
994 fi
995 fi
996 # false
997 return 1
0524c81f 998}
f7b2d235 999
18bd13ac 1000_modprobe() {
944d6d80 1001 local parsed single die args foo result
f7b2d235 1002 parsed=no
ac1f65e1 1003 while is_no "$parsed"; do
f7b2d235 1004 case "$1" in
739070c4 1005 "single")
8a835e11 1006 single=yes
1007 shift
1008 ;;
739070c4 1009 "die")
8a835e11 1010 die=yes
1011 shift
1012 ;;
739070c4 1013 -*)
8a835e11 1014 args="$args $1"
1015 shift
1016 ;;
739070c4 1017 *)
8a835e11 1018 parsed=yes
1019 ;;
f7b2d235
JR
1020 esac
1021 done
ac1f65e1 1022 if is_yes "${single}"; then
f7b2d235
JR
1023 foo="$@"
1024 show "Loading %s kernel module(s)" "$foo"
f7b2d235
JR
1025 busy
1026 fi
ac1f65e1 1027 if [ -x /sbin/modprobe ]; then
f7b2d235
JR
1028 /sbin/modprobe -s $args "$@"
1029 result=$?
1030 else
ac1f65e1 1031 deltext; fail
f7b2d235
JR
1032 result=1
1033 fi
ac1f65e1 1034 if is_yes "${single}"; then
f7b2d235 1035 deltext
ac1f65e1 1036 if [ $result = "0" ]; then
d553f606 1037 is_yes "$single" && ok
f7b2d235
JR
1038 else
1039 fail
ac1f65e1 1040 if is_yes "$die"; then
f7b2d235
JR
1041 nls "Could not load %s kernel module(s)" "$@"
1042 exit 1
1043 fi
1044 fi
1045 fi
f7b2d235 1046}
d553f606 1047
bc94aa53
ER
1048if is_no "$RC_LOGGING"; then
1049 log_success() {
1050 :
1051 }
d553f606 1052
18bd13ac 1053 log_failed() {
bc94aa53
ER
1054 :
1055 }
1056else
18bd13ac 1057 log_success() {
bc94aa53
ER
1058 initlog -n $0 -s "$1 $2" -e 1
1059 }
1060
18bd13ac 1061 log_failed() {
bc94aa53
ER
1062 initlog -n $0 -s "$1 $2" -e 2
1063 }
1064fi
d553f606 1065
f0c296a0
JR
1066# Check if any flavor of portmapper is running
1067check_portmapper() {
cbb91a00
ER
1068 if [ -x /usr/sbin/rpcinfo ]; then
1069 if /usr/sbin/rpcinfo -p localhost >/dev/null 2>/dev/null; then
fd8737b5 1070 return 0
f0c296a0
JR
1071 else
1072 return 1
1073 fi
5bf237b7
ER
1074 elif [ -z "$(pidof portmap)" -a -z "$(pidof rpcbind)" ]; then
1075 return 1
f0c296a0
JR
1076 fi
1077 return 0
1078}
1079
fab8c1a1
JR
1080# is_fsmounted fstype mntpoint
1081# Check if filesystem fstype is mounted on mntpoint
1082is_fsmounted() {
944d6d80
ER
1083 local fstype=$1
1084 local mntpoint=$2
fab8c1a1
JR
1085
1086 [ -n "$fstype" -a -n "$mntpoint" ] || return 1
1087
81ebaa15 1088 if [ -r /proc/mounts ]; then
bfd0227f 1089 grep -qE "[[:blank:]]$mntpoint[[:blank:]]+$fstype[[:blank:]]" /proc/mounts
81ebaa15 1090 return $?
fab8c1a1 1091 else
5bf237b7 1092 if [ "$(stat -L -f -c %T $mntpoint 2>/dev/null)" = "$fstype" ]; then
81ebaa15
JR
1093 return 0
1094 else
1095 return 1
1096 fi
fab8c1a1
JR
1097 fi
1098}
1099
83b3ef3b
AM
1100# __umount_loop awk_program fstab_file first_msg retry_msg umount_args
1101# awk_program should process fstab_file and return a list of fstab-encoded
1102# paths; it doesn't have to handle comments in fstab_file.
1103__umount_loop() {
1104 local remaining sig=
1105 local retry=3 count
1106
1107 remaining=$(LC_ALL=C awk "/^#/ {next} $1" "$2" | sort -r)
1108 while [ -n "$remaining" -a "$retry" -gt 0 ]; do
1109 if [ "$retry" -eq 3 ]; then
1110 run_cmd "$3" fstab-decode umount $5 $remaining
1111 else
1112 run_cmd "$4" fstab-decode umount $5 $remaining
1113 fi
1114 count=4
1115 remaining=$(LC_ALL=C awk "/^#/ {next} $1" "$2" | sort -r)
1116 while [ "$count" -gt 0 ]; do
1117 [ -z "$remaining" ] && break
1118 count=$(($count-1))
1119 usleep 500000
1120 remaining=$(LC_ALL=C awk "/^#/ {next} $1" "$2" | sort -r)
1121 done
1122 [ -z "$remaining" ] && break
a1170350 1123 fstab-decode /bin/fuser -k -m $sig $remaining >/dev/null
83b3ef3b
AM
1124 sleep 3
1125 retry=$(($retry -1))
1126 sig=-9
1127 done
1128}
1129
1130# Similar to __umount loop above, specialized for loopback devices
1131__umount_loopback_loop() {
1132 local remaining devremaining sig=
1133 local retry=3
1134
1135 remaining=$(awk '$1 ~ /^\/dev\/loop/ && $2 != "/" {print $2}' /proc/mounts)
1136 devremaining=$(awk '$1 ~ /^\/dev\/loop/ && $2 != "/" {print $1}' /proc/mounts)
1137 while [ -n "$remaining" -a "$retry" -gt 0 ]; do
1138 if [ "$retry" -eq 3 ]; then
1139 run_cmd "Unmounting loopback filesystems: " \
1140 fstab-decode umount $remaining
1141 else
1142 run_cmd "Unmounting loopback filesystems (retry):" \
1143 fstab-decode umount $remaining
1144 fi
1145 for dev in $devremaining ; do
1146 losetup $dev > /dev/null 2>&1 && \
1147 run_cmd "Detaching loopback device $dev: " \
1148 losetup -d $dev
1149 done
1150 remaining=$(awk '$1 ~ /^\/dev\/loop/ && $2 != "/" {print $2}' /proc/mounts)
1151 devremaining=$(awk '$1 ~ /^\/dev\/loop/ && $2 != "/" {print $1}' /proc/mounts)
1152 [ -z "$remaining" ] && break
a1170350 1153 fstab-decode /bin/fuser -k -m $sig $remaining >/dev/null
83b3ef3b
AM
1154 sleep 3
1155 retry=$(($retry -1))
1156 sig=-9
1157 done
1158}
1159
0084dcf3 1160rc_cache_init() {
6e311c54
ER
1161 # If we have cachefile, use it.
1162 # If we don't, create memory variables and try to save silently,
acf05b4f 1163 local cachefile='/var/cache/rc-scripts/msg.cache'
0084dcf3 1164
4132441e
ER
1165 local term
1166 if is_yes "$ISATTY"; then
1167 term=$TERM
1168 else
1169 term=dumb
1170 fi
1171
0084dcf3
ER
1172 # We create $check variable which is used to invalidate the cache.
1173 # The $check contains user locale and terminal.
66f7cfac 1174 local check="$term.$LC_MESSAGES.$INIT_COL"
0084dcf3 1175
f9df72e7 1176 if [ -f "$cachefile" -a "$cachefile" -nt /etc/sysconfig/system -a "$cachefile" -nt /etc/sysconfig/init-colors ]; then
0084dcf3
ER
1177 if . "$cachefile" 2>/dev/null; then
1178 if [ "$check" = "$_check" ]; then
1179 return
1180 fi
1181 fi
f9df72e7
ER
1182 fi
1183
1184 # primitive caching
1185 _busy=$(progress "BUSY" "$CBUSY")
1186 _ok=$(progress "DONE")
1187 _started=$(progress "WORK")
1188 _fail=$(progress "FAIL" "$CFAIL")
1189 _died=$(progress "DIED" "$CFAIL")
cc54351b
ER
1190
1191 # we don't use heredoc, as ksh attempts to create tempfile then
3ba0bc12 1192 (> "$cachefile" ) 2>/dev/null || return
cc54351b
ER
1193 echo "_busy='$_busy';" >> "$cachefile"
1194 echo "_ok='$_ok';" >> "$cachefile"
1195 echo "_started='$_started';" >> "$cachefile"
1196 echo "_fail='$_fail';" >> "$cachefile"
1197 echo "_died='$_died';" >> "$cachefile"
1198 echo "_check='$check';" >> "$cachefile"
f9df72e7
ER
1199}
1200
0084dcf3 1201rc_gettext_init() {
9a0a016d
ER
1202 if [ -z "$GETTEXT" ]; then
1203 if [ -x /bin/gettext -o -x /usr/bin/gettext ]; then
1204 GETTEXT=yes
1205 else
1206 GETTEXT=no
1207 fi
1208 fi
1209
1210 if [ -z "$TPUT" ]; then
ac1f65e1 1211 if [ -d /usr/share/terminfo ] && [ -x /usr/bin/tput -o -x /bin/tput ]; then
9a0a016d
ER
1212 TPUT=yes
1213 # check if we are on proper terminal
1214 tput longname >/dev/null 2>&1 || TPUT=no
1215 else
1216 TPUT=no
1217 fi
1218 fi
1219}
1220
439b6d80
JK
1221use_upstart () {
1222 # True when upstart-event-based boot should be used
1223 is_yes "$USE_UPSTART" && return 0
1224 is_no "$USE_UPSTART" && return 1
1225 if [ ! -x /sbin/initctl ] ; then
1226 USE_UPSTART="no"
1227 return 1
1228 fi
13b36c6c 1229 local cmdline=$(cat /proc/cmdline 2>/dev/null)
439b6d80
JK
1230 if strstr "$cmdline" "pld.no-upstart" ; then
1231 USE_UPSTART="no"
1232 return 1
1233 else
1234 USE_UPSTART="yes"
1235 return 0
1236 fi
1237}
1238
1239emit () {
1240 # emit upstart signal
1241 # only when 'upstart' boot is enabled
1242 use_upstart || return 0
1243 /sbin/initctl emit "$@"
1244}
1245
9ee04f3b
JK
1246is_upstart_task() {
1247 # Return 0 if the given service is an upstart task.
1248 grep -q '^task' "/etc/init/$1.conf"
1249}
1250is_upstart_running() {
1251 # Return 0 if the given service is running via upstart
1252 initctl status "$1" 2>/dev/null | grep -q running
1253}
1254upstart_start() {
1255 local service=$1
516bc26f
ER
1256 if is_upstart_running "${service}"; then
1257 msg_already_running "$service"
1258 return 0
1259 fi
1260
9ee04f3b
JK
1261 msg_starting "${service}"
1262 if errors=$(/sbin/initctl start ${service} 2>&1) ; then
1263 ok
439b6d80 1264 return 0
9ee04f3b
JK
1265 else
1266 fail
1267 echo "$errors" >&2
1268 return 1
1269 fi
1270}
1271upstart_stop() {
1272 local service=$1
516bc26f
ER
1273 if ! is_upstart_running "${service}"; then
1274 msg_not_running "$name"
9ee04f3b
JK
1275 return 0
1276 fi
1277 msg_stopping "${service}"
1278 if errors=$(/sbin/initctl stop ${service}) ; then
1279 ok
1280 return 0
1281 else
1282 fail
1283 echo "$errors" >&2
1284 return 1
1285 fi
1286}
1287upstart_reload() {
1288 local service=$1
1289 if ! is_upstart_running "${service}" && ! is_upstart_task "${service}" ; then
1290 return 0
1291 fi
1292 msg_reloading "${service}"
1293 if errors=$(/sbin/initctl reload ${service}) ; then
1294 ok
1295 return 0
1296 else
1297 fail
1298 echo "$errors" >&2
1299 return 1
1300 fi
1301}
1302upstart_status() {
1303 # get service status
1304 # should be compliant with
7e7efad2 1305 # http://refspecs.freestandards.org/LSB_3.1.1/LSB-Core-generic/LSB-Core-generic/iniscrptact.html
9ee04f3b
JK
1306 local service=$1
1307 local status
1308 if is_upstart_task "${service}" ; then
1309 # we probably should have a way to handle task status
439b6d80
JK
1310 return 0
1311 fi
9ee04f3b
JK
1312 if ! status=$(/sbin/initctl status "${service}") ; then
1313 # program or service status is not known
1314 return 4
1315 fi
1316 if strstr "$status" "running" ; then
1317 # program is running or service is OK
945d7cfd 1318 echo "$status"
9ee04f3b
JK
1319 return 0
1320 else
1321 # program is not running
945d7cfd 1322 echo "$status"
9ee04f3b
JK
1323 return 3
1324 fi
1325 # TODO: other statuses
1326}
1327
6ca2a6ab 1328_upstart_controlled() {
9ee04f3b
JK
1329 # If the service is to be handled by upstart
1330 # execute the start/stop/etc. commands the upstart way
6ca2a6ab 1331 if ! use_upstart; then
9ee04f3b 1332 return 0
6ca2a6ab 1333 fi
9ee04f3b
JK
1334 local script=$1
1335 shift
1336 local command=$1
6ca2a6ab 1337 [ $# -gt 0 ] && shift
9ee04f3b 1338 local name=$(basename "$script")
439b6d80
JK
1339 if [ ! -f /etc/init/${name}.conf ] ; then
1340 return 0
1341 fi
9b1f5468
JK
1342 local commands
1343 local extra_commands
02271277 1344 local has_configtest
9b1f5468
JK
1345 if [ "$1" = "--except" ] ; then
1346 shift
1347 commands="$*"
1348 for cmd in $commands ; do
1349 if [ "$command" = "$cmd" ] ; then
1350 return 0
1351 fi
1352 case "$cmd" in
1353 start|stop|status|reload|restart|try-restart|force-reload)
1354 ;;
02271277
JK
1355 configtest)
1356 has_configtest=yes
1357 extra_commands="|$cmd"
1358 ;;
9b1f5468
JK
1359 *)
1360 extra_commands="|$cmd"
1361 ;;
1362 esac
1363 done
1364 elif [ -n "$*" ] ; then
1365 commands="$*"
9ee04f3b
JK
1366 local cmd
1367 local found=0
1368 # is there a better way
1369 for cmd in $commands ; do
1370 if [ "$command" = "$cmd" ] ; then
1371 found=1
1372 break;
1373 fi
1374 done
1375 if [ $found = 0 ] ; then
1376 # let the script handle it
1377 return 0
1378 fi
1379 fi
439b6d80 1380 case "$command" in
9ee04f3b
JK
1381 start)
1382 upstart_start $name
1383 exit $?
1384 ;;
1385 stop)
1386 upstart_stop $name
1387 exit $?
1388 ;;
1389 status)
1390 upstart_status $name
1391 exit $?
1392 ;;
1393 restart)
023f83d5 1394 if is_yes "$has_configtest" ; then
02271277
JK
1395 "$script" configtest || exit 1
1396 fi
9ee04f3b
JK
1397 upstart_stop $name
1398 upstart_start $name
1399 exit $?
1400 ;;
d5a0dae5
JK
1401 try-restart)
1402 if ! is_upstart_running "$name" ; then
1403 exit 0
1404 fi
023f83d5 1405 if is_yes "$has_configtest" ; then
02271277
JK
1406 "$script" configtest || exit 1
1407 fi
d5a0dae5
JK
1408 upstart_stop $name
1409 upstart_start $name
1410 exit $?
1411 ;;
9ee04f3b 1412 reload)
023f83d5 1413 if is_yes "$has_configtest" ; then
02271277
JK
1414 "$script" configtest || exit 1
1415 fi
9ee04f3b
JK
1416 if is_upstart_task "$name" ; then
1417 nls "$command not implemented for $name"
1418 exit 3
1419 else
1420 upstart_reload "$name"
1421 exit $?
1422 fi
1423 ;;
1424 force-reload)
023f83d5 1425 if is_yes "$has_configtest" ; then
02271277
JK
1426 "$script" configtest || exit 1
1427 fi
9ee04f3b
JK
1428 if is_upstart_task "$name" ; then
1429 upstart_stop "$name"
1430 upstart_start "$name"
1431 exit $?
1432 else
1433 upstart_reload "$name"
1434 exit $?
1435 fi
439b6d80
JK
1436 ;;
1437 *)
6ca2a6ab 1438 msg_usage "$0 {start|stop|restart|reload|force-reload|status$extra_commands}"
9ee04f3b 1439 exit 3
439b6d80
JK
1440 ;;
1441 esac
9ee04f3b 1442 return 1 # should not happen
439b6d80 1443}
9ee04f3b
JK
1444
1445# Usage:
7e7efad2 1446# somewhere at the begining of init script:
9ee04f3b
JK
1447# upstart_controlled
1448# - to pass implement all upstart commands via initctl
1449# start, stop, status, restart, reload and force_reload
1450# are implemented
1451# upstart_controlled command...
1452# - to pass handle only specific commands the upstart way
1453# and leave the rest to the script
1454#
945d7cfd 1455alias upstart_controlled='_upstart_controlled $0 "$@"'
439b6d80 1456
0084dcf3
ER
1457rc_gettext_init
1458rc_cache_init
f9df72e7 1459
bbb612de
AM
1460#/*
1461# * Local variables:
1462# * mode: sh
1463# * indent-tabs-mode: notnil
1464# * End:
1465# *
bbb612de 1466# */
This page took 1.163327 seconds and 4 git commands to generate.